<template>
    <v-layout row justify-center>
        <v-dialog v-model="dialogDataProp" width="600px" height="600px">
            <v-card>
                <v-card-title>
                    <span class="headline">Clinia Externa</span>
                </v-card-title>

                <v-card-text style="height: 500px;">

                    <v-flex xs12 sm12 md12 v-bind:class="{ 'error': listErrors.consigned_id }">
                        <autocomplete 
                            :source="apiServer" 
                            v-model="consigned_id" 
                            placeholder="Clientes" 
                            results-property="items" 
                            :request-headers="authHeaders" 
                            :results-display="formattedDisplay">
                            </autocomplete>
                        <span v-if="listErrors.consigned_id"> {{ listErrors.consigned_id }} </span>
                    </v-flex>

                    <v-flex xs12 sm12 md12>
                        <v-text-field v-model="citologias" type="number" label="Citologías" required></v-text-field>
                    </v-flex>

                    <v-flex xs12 sm12 md12>
                        <v-text-field v-model="biopsias" type="number" label="Biopsias" required></v-text-field>
                    </v-flex>

                    <v-flex xs12 sm12 md12>
                        <v-textarea name="input-7-1" label="Anotaciones" v-model="notes">
                        </v-textarea>
                    </v-flex>

                    <upload-image v-model="image" />

                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="error" flat @click="closeDialog">
                        Cerrar
                    </v-btn>

                    <v-btn color="primary" flat @click="onUpdate">
                        Ingresar
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>

<script>
import Autocomplete from 'vuejs-auto-complete'
import UploadImage from '../UploadImage'
import axios from 'axios';
import server from '../../server'

export default {
    name: 'TaskDialogClinicaExterna',
    props: {
        dialog: Boolean
    },
    components: {
        Autocomplete,
        UploadImage
    },
    data() {
        return {
            citologias: 1,
            biopsias: 1,
            notes: '',
            consigned_id: '',
            counter: 0,
            image: '',
            listErrors: [],
            apiServer: `${server}/api/clientes?name=`,

        }
    },
    methods: {
        closeDialog() {
            this.clearDialog();
            this.$emit('close-dialog')
        },
        formattedDisplay(result) {
            return result.name
        },
        async onUpdate(e) {
            e.preventDefault();

            const datos = {
                citologias: this.citologias,
                biopsias: this.biopsias,
                notes: this.notes,
                consigned_id: this.consigned_id,
                task_id: this.$route.params.id,
                image: this.image,
                clear: false,
                type: 3
            }

            let self = this;
            await axios.post(`${server}/api/task/clinicas-externas/store`, datos, {
                headers: {
                    Authorization: this.$store.getters.getAccessToken
                }
            }).then((rest) => {
                this.setTaskDetail(this.$route.params.id);
                this.closeDialog()
            }).catch((er) => {
                this.listErrors = er.response.data.errors
                console.log(er.response)
            });
        },
        setTaskDetail(id) {
            this.$store.dispatch('setTaskClinicaExternasDetail', id).then((res) => {
                console.log(res);
            });
        },
        clearDialog() {
            this.examenes = 1;
            this.muestras = 1;
            this.loads = null;
            this.image = '';
            this.listErrors = [];
            this.clear= true,
            this.task_id = '';
        },

    },
    computed: {
        dialogDataProp: {
            get: function () {
                return this.dialog
            },
            set() {}
        },
        authHeaders() {
            return {
                'Authorization': this.$store.getters.getAccessToken
            }
        },

    }
}
</script>

<style>

</style>
